PROGRAM ahorcado;

GLOBAL
    palabras[]="AHORCADO","BATIDORA","MOLINILLO","BOTARATE","INFIERNO",
               "CELESTE","AMARILLO","VIOLETA","NARANJA","BLANCO",

               "AZUL","ROJO","NEGRO","VERDE","ROSA",
               "PASTEL","CARAMELO","PIRUTELA","CHICLE","CHOCOLATE",

               "DIOS","DIEZ","DIVA","DEDO","DUDA",
               "PATO","LETRA","RATA","PITA","PATA",

               "HOMINIDOS","MAMIFEROS","AVICOLAS","CRUSTACEOS","ROEDORES",
               "FRENESI","DESENFRENO","LUJURIA","ORGIASTICO","RUDIMENTARIO",

               "LOCOMOTORA","HIDROAVION","TRANSATLANTICO","LANCHA","BUQUE",
               "SIMIENTE","MELANINA","HIPOCONDRIACO","EXTREMISTA","RUMBOSO",


               "LUJO","ODIO","SOLO","POLO","RUTA",
               "TRES","CUATRO","CINCO","SEIS","SIETE",

               "JUEGO","ORDENADOR","TECLADO","RATON","MONITOR",
               "COCHE","CAMION","FURGONETA","MOTOCICLETA","BICICLETA",

               "FABRICA","TORNILLO","HERRAMIENTA","OBRERO","FICHA",
               "ZAMORANO","TOLEDANO","PACENSE","FRANCES","INGLES",

               "HABLAR","MEDIANOCHE","GENTE","CASOS","ANECDOTA",
               "HABLANDO","COMIENDO","DURMIENDO","TOSIENDO","FUMANDO",

               "INDIGNADA","EXPOSICION","CUADROS","EXHIBICION","PENALIDAD",
               "INGLATERRA","RETRATOS","TREMENDO","ALTRUISTA","DINERO",

               //--------------100

               "BENDECIDO","NOCHES","TELEFONO","RADIO","DOMINO",
               "ENCONTRADO","DOCUMENTACION","CARNET","PAPEL","RECIBO",

               "REFERENCIA","POLICIA","ENTIENDES","GRACIAS","AGRADECIDO",
               "ESCUCHANDO","CADENA","ANILLO","GAFAS","MIRILLA",

               "RESPONDER","TRASLADO","PRESOS","TERRORISTA","CERCANO",
               "INSIPIDO","MATANDO","REINVINDICANDO","MANIFESTACION","MUJERES",

               "HOMBRES","ANCIANOS","MALTRATO","ASQUEROSO","DENUNCIAR",
               "DEFENSA","CABEZA","HISTORIAS","DELITOS","EXPLICACION",

               "DEMOCRACIA","AVANZADO","PRIVILEGIOS","CONSEGUIR","INTENTAR",
               "PACIFICAR","PRINCIPIOS","MOTIVOS","IDEALES","GUIA",


               "MAFIA","INDEPENDENCIA","DESESTABILIZAR","GOBIERNO","IMPOSIBLE",
               "REGION","GUERRA","SANGRE","ACUERDOS","ASESINOS",

               "FOTOGRAFICA","BUENO","MALVADO","TREMENDO","SENTIMIENTO",
               "ORGANIGRAMA","FAMOSO","TAROT","CONTINUAMOS","MALAGA",

               "SALIDA","ENTRADA","ENGANCHAR","COMUNIDAD","BENEFICO",
               "MONTAJE","ADELANTE","PADRES","MADRES","HIJOS",

               "ESPOSO","TOROS","CORRIDAS","QUINIELA","FACTURACION",
               "SABER","DISCOS","VIDEOS","AGENDA","ALMACEN",

               "PERDIDA","GANADA","GANADO","ZAPATILLA","DESTINO",
               "PERFECTA","COMENTARIO","LASTIMA","ALACRAN","BEBIDA"

    ;

    numeroelegida;
    longitudelegida;
    textoelegido;
    textoletras[10];
    numerodefallos;
    letracogida;
    letrasconseguidas;
    findejuego;
LOCAL
    contador1;


IMPORT "ascii.dll";

BEGIN
    set_mode(m640x480);
    load_fpg("..\ahorca\ahorca.fpg");
    load_fnt("..\ahorca\ahorca00.fnt");
    LOOP
        put_screen(0,1);
        inicializa_juego();
        fade_on();
        WHILE (not key(_esc) AND findejuego==0)
            IF (ascii<>0)
                letracogida=ascii;
                comprueba_letra();
                ascii=0;
            END
            FRAME;
        END
        fade_off();
        let_me_alone();
        delete_text(all_text);
    END

END

PROCESS inicializa_juego()


BEGIN
    numeroelegida=rand(0,49);
    longitudelegida=ascii_len(palabras[numeroelegida]);
    textoelegido=ascii_dup(45,longitudelegida);
    write(1,320,300,4,"Adivina la palabra");
    write(1,320,370,4,"Elige una letra");
    write(1,320,440,4,textoelegido);

    FROM contador1=0 to 10;
        textoletras[contador1]=ascii_dup(35,1);
    END
    FROM contador1=0 to 9;
        write(1,290+((contador1%5)*75),120+((contador1/5)*75),4,textoletras[contador1]);
    END
    numerodefallos=0;
    letrasconseguidas=0;
    findejuego=0;
    ponahorcado();
    LOOP
        FRAME;
    END
END

PROCESS ponahorcado()
BEGIN
    x=120;
    y=120;
    LOOP
        graph=numerodefallos+10;
        FRAME;
    END
END

PROCESS comprueba_letra()
PRIVATE
    sinfallo=1;
    letrapalabra;
    sinrepetir;
BEGIN

    if (letracogida>96 AND letracogida<123 )
            letracogida-=32;
    end

    if (letracogida>64 AND letracogida<91)
        sinfallo=1;
        FOR (contador1=0;contador1<longitudelegida;contador1++)
            letrapalabra=ascii_getchar(palabras[numeroelegida],contador1);
            IF (letracogida==letrapalabra)
                sinfallo=0;
                IF (ascii_getchar(textoelegido,contador1)==45)
                    ascii_setchar(textoelegido,contador1,letracogida);
                    letrasconseguidas++;
                    if (letrasconseguidas==longitudelegida)
                        findejuego=2;
                        break;
                    END
                END
            END
        END
        if (sinfallo==1)
            sinrepetir=0;
            FOR (contador1=0;contador1<numerodefallos;contador1++)
                letrapalabra=ascii_getchar(textoletras[contador1],0);
                IF (letracogida==letrapalabra)
                    sinrepetir=1;
                    break;
                END
            END
            IF (sinrepetir==0)
                ascii_setchar(textoletras[numerodefallos],0,letracogida);
                numerodefallos++;
                IF (numerodefallos==10)
                    findejuego=1;
                END
            end
        END
    end
    FRAME;
END